package fernandoalvarez.eventizer.Chats

import android.util.Log
import com.google.android.gms.tasks.OnSuccessListener
import com.google.firebase.database.ChildEventListener
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.Message

class ChatPresenter(private val chatFragment: ChatFragment) {
    lateinit var eventId: String

/*    fun getMessages(eventId: String) {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val iterator = dataSnapshot.children.iterator()
                    iterator.forEach {
                        val message = it.getValue(Message::class.java)
                        message?.id = it.key
                        chatFragment.addMessage(message!!)
                    }

                }

            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }

        }

        FirebaseUtil.getMessages(listener,eventId)

    }*/

    fun getUsername()
    {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                chatFragment.setUsernameInfo(dataSnapshot.value.toString())
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getUsername(listener)

    }

    /*fun getEventById(id:String)
    {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val event = dataSnapshot.getValue(Event::class.java)
                    chatFragment.setEventData(event!!)
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }

        FirebaseUtil.getEventById(listener, id)
    }*/

    fun sendMessage(message: Message)
    {
        val listener = OnSuccessListener<Void>
        {
            Log.d("Chat","Message Send" + message.text)
        }

        FirebaseUtil.addNewMessage( listener, eventId,message )
    }

    fun deleteMessage(message: Message, eventId:String)
    {
        val listener = OnSuccessListener<Void>
        {
            Log.d("Chat","Message Deleted" + message.text)
        }
        FirebaseUtil.deleteMessage(listener,eventId,message.id)
    }

    fun listenForChanges() {
        val listener = object : ChildEventListener {
            override fun onChildMoved(p0: DataSnapshot?, p1: String?) {
                TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
            }

            override fun onChildChanged(p0: DataSnapshot?, p1: String?) {
                TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
            }

            override fun onChildAdded(p0: DataSnapshot?, p1: String?) {
                val newMessage = p0?.getValue(Message::class.java)
                chatFragment.addMessage(newMessage!!)
            }
            override fun onChildRemoved(p0: DataSnapshot?) {
                val newMessage = p0?.getValue(Message::class.java)
                chatFragment.deleteMessage(newMessage!!)
            }

            override fun onCancelled(p0: DatabaseError?) {
                TODO("not implemented") //To change body of created functions use File | Settings | File Templates.
            }

        }
        FirebaseUtil.listenForMessagesChanges(listener,eventId)
    }





}

