package fernandoalvarez.eventizer.Chats

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.Message
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.messages_layout.view.*
import java.text.SimpleDateFormat
import java.util.*

class MessagesAdapter(val messagesList: ArrayList<Message>, private val clickListener: (Message) -> Unit, private val isAdmin: Boolean):
RecyclerView.Adapter<MessagesAdapter.ViewHolder>()

{
    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(messagesList[position], clickListener, isAdmin)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): MessagesAdapter.ViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.messages_layout, parent, false)
        return MessagesAdapter.ViewHolder(v)
    }


    override fun getItemCount(): Int {
        return messagesList.size
    }


    class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView){
        fun bind(message: Message, clickListener: (Message) -> Unit, isAdmin: Boolean) {
            if (isAdmin)
            {itemView.trashIcon.visibility=View.VISIBLE}
            itemView.messageText.text = message.text
            val formatter = SimpleDateFormat("dd/MM/yyyy HH:mm",Locale.getDefault())
            val cal = Calendar.getInstance()
            cal.timeInMillis = message.timestamp.toLong()
            itemView.messageDate.text = formatter.format(cal.time)
            itemView.messageSender.text = message.sender
            itemView.trashIcon.setOnClickListener { clickListener(message) }
        }
    }
}