package fernandoalvarez.eventizer.Contacts

import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.User

class AddContactPresenter(val addContactActivity: AddContactActivity) {

    fun addNewContact(email: String)
    {
        val listener = object : ValueEventListener {

            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                   val firstChild= dataSnapshot.children.iterator().next()
                    val user = firstChild.getValue(User::class.java)
                    user?.id=firstChild.key.toString()
                    FirebaseUtil.addNewContact(user!!)
                    addContactActivity.showAddedUserMessage(user)
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getUserByMail(listener,email)
    }

}