package fernandoalvarez.eventizer.Contacts

import com.google.android.gms.tasks.OnSuccessListener
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.User

class ContactListPresenter(val contactsListFragment: ContactsListFragment) {

    fun getContacts() {
        contactsListFragment.hideProgressBar()
        val listener = object : ValueEventListener {

            override fun onDataChange(dataSnapshot: DataSnapshot) {
                    if (dataSnapshot.hasChildren()) {
                    val p = dataSnapshot.value as HashMap<String,String>
                    p.keys.forEach{
                        getUserById(it)
                    }
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }

        FirebaseUtil.getContactsIds(listener)
    }

    private fun getUserById(id: String) {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val contact = dataSnapshot.getValue(User::class.java)
                    if (contact != null) {
                        contact.id = id
                        contactsListFragment.addContact(contact)
                    }
                }

            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getUserById(listener, id)
    }

    fun deleteUser(user: User)
    {
        val listener = OnSuccessListener<Void> {
            contactsListFragment.showDeletedUserMessage(user)
        }
        FirebaseUtil.deleteContact(user,listener)
    }

}

