package fernandoalvarez.eventizer.Contacts

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.User
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.contacts_layout.view.*

class ContactsAdapter (val contactsList: ArrayList<User>,
                       private val clickListener: (User) -> Unit):
        RecyclerView.Adapter<ContactsAdapter.ViewHolder>() {

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(contactsList[position], clickListener)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.contacts_layout, parent, false)
        return ViewHolder(v)
    }

    override fun getItemCount(): Int {
        return contactsList.size
    }

    class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView){
        fun bind(contact: User, clickListener: (User) -> Unit) {
            itemView.usernameText.text = contact.username
            itemView.emailText.text = contact.email
            itemView.trashIcon.setOnClickListener { clickListener(contact) }
        }
    }

}