package fernandoalvarez.eventizer.Contacts

import android.os.Bundle
import android.support.design.widget.FloatingActionButton
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.content.Intent
import android.widget.Toast
import fernandoalvarez.eventizer.Model.User
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.fragment_contacts_list.*

class ContactsListFragment : Fragment() {

    private var contactListPresenter: ContactListPresenter = ContactListPresenter(this)
    private var layoutManager: RecyclerView.LayoutManager? = null
    private var adapter: RecyclerView.Adapter<ContactsAdapter.ViewHolder>? = null
    private var contacts = ArrayList<User>()

    override fun onStart() {
        super.onStart()
        contacts.clear()
        contactListPresenter.getContacts()
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {

        val view=inflater.inflate(R.layout.fragment_contacts_list, container, false)

        layoutManager = LinearLayoutManager(context)

        val rv = view.findViewById(R.id.contactsList) as RecyclerView
        rv.layoutManager = layoutManager

        adapter = ContactsAdapter(contacts, this::contactClicked)
        rv.adapter = adapter

        val fab = view.findViewById(R.id.addButton) as FloatingActionButton
        fab.setOnClickListener {
            val intent = Intent(activity, AddContactActivity::class.java)
            startActivity(intent)
        }

        return view
    }

    fun addContact(contact: User)
    {
        contacts.add(contact)
        this.adapter?.notifyDataSetChanged()
    }

    private fun contactClicked(contact: User)
    {
     contactListPresenter.deleteUser(contact)
    }

    fun showDeletedUserMessage(user:User)
    {
        contacts.remove(user)
        this.adapter?.notifyDataSetChanged()
        Toast.makeText(this.context, "Usuario "+user.username + " borrado", Toast.LENGTH_SHORT).show()
    }

    fun hideProgressBar()
    {
        if (progressBar!=null)
        progressBar.visibility = View.GONE
    }

}
