package fernandoalvarez.eventizer.Contacts

import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.View
import android.widget.Toast
import fernandoalvarez.eventizer.Model.User
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.fragment_events_list.*

class ContactsSelectionActivity : AppCompatActivity() {

    private var contactsSelectionPresenter: ContactsSelectionPresenter = ContactsSelectionPresenter(this)
    private var layoutManager: RecyclerView.LayoutManager? = null
    private var adapter: RecyclerView.Adapter<ContactsSelectionAdapter.ViewHolder>? = null
    private var contacts = ArrayList<User>()
    private lateinit var eventId:String

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        eventId = intent.getStringExtra("eventId")
        contactsSelectionPresenter.setEventId(eventId)

        setContentView(R.layout.activity_contacts_selection)


        layoutManager = LinearLayoutManager(this)

        val rv = findViewById<RecyclerView>(R.id.contactsList)
        rv.layoutManager = layoutManager

        adapter = ContactsSelectionAdapter(contacts, this::contactClicked)
        rv.adapter = adapter

        contactsSelectionPresenter.getContacts()
        hideProgressBar()
    }

    fun addContact(contact: User)
    {
        contacts.add(contact)
        this.adapter?.notifyDataSetChanged()
    }

    private fun contactClicked(contact: User, switchState: Boolean)
    {
        if (switchState)
        {
            contactsSelectionPresenter.inviteUserToEvent(contact.id)
        }
        else
        {
            contactsSelectionPresenter.removeUserFromEvent(contact.id)
        }
    }

    fun showUserRemovedMessage()
    {
        Toast.makeText(this,"user removed" , Toast.LENGTH_SHORT).show()
    }

    private fun hideProgressBar()
    {
        if (progressBar!=null)
            progressBar.visibility = View.GONE
    }

}
