package fernandoalvarez.eventizer.Contacts

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.CompoundButton
import fernandoalvarez.eventizer.Model.User
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.contacts_selection_layout.view.*
import kotlin.reflect.KFunction2

class ContactsSelectionAdapter (val contactsList: ArrayList<User>,
                                private val clickListener: KFunction2<@ParameterName(name = "contact") User, @ParameterName(name = "switchState") Boolean, Unit>):
        RecyclerView.Adapter<ContactsSelectionAdapter.ViewHolder>() {

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(contactsList[position], clickListener)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.contacts_selection_layout, parent, false)
        return ViewHolder(v)
    }

    override fun getItemCount(): Int {
        return contactsList.size
    }

    class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView){
        fun bind(contact: User, clickListener: (User,Boolean) -> Unit) {
            itemView.usernameText.text = contact.username
            itemView.emailText.text = contact.email
            itemView.contactSwitch.isChecked = contact.member
            itemView.contactSwitch.setOnCheckedChangeListener { _: CompoundButton, b: Boolean -> clickListener(contact,b) }
        }
    }

}