package fernandoalvarez.eventizer.Contacts

import com.google.android.gms.tasks.OnSuccessListener
import com.google.firebase.database.ChildEventListener
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.User

class ContactsSelectionPresenter(val contactsSelectionActivity: ContactsSelectionActivity) {

    private val contacts: ArrayList<User> = ArrayList()
    private lateinit var eventId:String
    private lateinit var p: HashMap<String,String>

    fun getContacts() {
        val listener = object : ValueEventListener {

            override fun onDataChange(dataSnapshot: DataSnapshot) {
                //contactsListFragment.hideProgressBar()
                if (dataSnapshot.hasChildren()) {
                    val c = dataSnapshot.value as HashMap<String,String>
                    c.keys.forEach{
                        getUserById(it)
                    }
                    getUsersFromEvent()
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }

        FirebaseUtil.getContactsIds(listener)
    }

    private fun getUserById(id: String) {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val contact = dataSnapshot.getValue(User::class.java)
                    if (contact != null) {
                        contact.id=id
                        contacts.add(contact)
                    }
                }

            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getUserById(listener, id)
    }

    fun getUsersFromEvent()
    {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    p = dataSnapshot.value as HashMap<String,String>
                    areUsersInEvent()
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getUsersFromEvent(listener,eventId)
    }

    fun areUsersInEvent()
    {
        for (contact in contacts) {
            if(p.containsKey(contact.id))
            {
                contact.member=true
            }
            contactsSelectionActivity.addContact(contact)
        }

    }

    fun setEventId(eventId: String)
    {
        this.eventId=eventId
    }

    fun inviteUserToEvent(userId:String)
    {
        val listener = OnSuccessListener<Void> {

        }
        FirebaseUtil.inviteUserToEvent(listener,eventId,userId)
    }

    fun removeUserFromEvent(userId:String)
    {
        val listener = OnSuccessListener<Void> {
            contactsSelectionActivity.showUserRemovedMessage()
        }
        FirebaseUtil.removeUserFromEvent(listener,eventId,userId)
    }

}