package fernandoalvarez.eventizer.Events

import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.activity_event_detail.*
import android.support.design.widget.TabLayout
import android.support.v4.app.Fragment
import android.support.v4.app.FragmentManager
import android.support.v4.app.FragmentPagerAdapter
import fernandoalvarez.eventizer.Chats.ChatFragment
import fernandoalvarez.eventizer.Contacts.ContactsListFragment
import fernandoalvarez.eventizer.Model.Event

class EventDetailActivity : AppCompatActivity() {

    private var mSectionsPagerAdapter: EventDetailActivity.SectionsPagerAdapter? = null
    private lateinit var  eventDetailPresenter: EventDetailPresenter
    private lateinit var event: Event
    private lateinit var userId: String

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        eventDetailPresenter = EventDetailPresenter(this)
        val eventId = intent.getStringExtra("eventId")
        eventDetailPresenter.getEventById(eventId)
        eventDetailPresenter.getUserInfo()
        setContentView(R.layout.activity_event_detail)
    }


    inner class SectionsPagerAdapter(fm: FragmentManager) : FragmentPagerAdapter(fm) {

        override fun getItem(position: Int): Fragment {
            // getItem is called to instantiate the fragment for the given page.
            // Return a PlaceholderFragment (defined as a static inner class below).

            return when (position) {
                0 -> EventDetailFragment().newInstance(event,userId)
                1 -> ChatFragment().newInstance(event,userId)
                else -> {
                    ContactsListFragment()
                }
            }
        }

        override fun getCount(): Int {
            // Show 2 total pages.
            return 2
        }

    }
    private fun initializeSectionPager()
    {
        mSectionsPagerAdapter = SectionsPagerAdapter(supportFragmentManager)
        container.adapter = mSectionsPagerAdapter
        container.addOnPageChangeListener(TabLayout.TabLayoutOnPageChangeListener(tabs))
        tabs.addOnTabSelectedListener(TabLayout.ViewPagerOnTabSelectedListener(container))
    }

    fun setEventData(event:Event)
    {
        this.event = event
        this.initializeSectionPager()
    }

    fun setUserInfo(userId:String)
    {
        this.userId = userId
    }

}
