package fernandoalvarez.eventizer.Events

import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.Event

class EventDetailPresenter(private val eventDetailActivity: EventDetailActivity) {

    fun getEventById(id:String)
    {
        val listener = object : ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val event = dataSnapshot.getValue(Event::class.java)
                    eventDetailActivity.setEventData(event!!)
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getEventById(listener, id)
    }

    fun getUserInfo()
    {
        val id = FirebaseUtil.getUserId()
        eventDetailActivity.setUserInfo(id)
    }

}