package fernandoalvarez.eventizer.Events

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.Event
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.events_layout.view.*

class EventsAdapter (val eventsList: ArrayList<Event>, private val clickListener: (Event) -> Unit): RecyclerView.Adapter<EventsAdapter.ViewHolder>() {

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(eventsList[position], clickListener)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.events_layout, parent, false)
        return ViewHolder(v)
    }

    override fun getItemCount(): Int {
        return eventsList.size
    }

    class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView){
        fun bind(event: Event, clickListener: (Event) -> Unit) {
            itemView.eventTitle.text = event.title
            itemView.eventDate.text = event.date
            itemView.eventTime.text = event.time
            itemView.setOnClickListener { clickListener(event) }
        }
    }
}