package fernandoalvarez.eventizer.Events

import android.content.Intent
import android.os.Bundle
import android.support.design.widget.FloatingActionButton
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.Event
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.fragment_events_list.*

class EventsListFragment : Fragment() {

    private lateinit var  eventsListPresenter: EventsListPresenter
    private var layoutManager: RecyclerView.LayoutManager? = null
    private var adapter: RecyclerView.Adapter<EventsAdapter.ViewHolder>? = null
    private var events = ArrayList<Event>()
    private var flag:Boolean = false

    override fun onStart() {
        super.onStart()
        hideProgressBar()
    }

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {

        eventsListPresenter = EventsListPresenter(this)

        val view = inflater.inflate(R.layout.fragment_events_list, container,false)

        layoutManager = LinearLayoutManager(context)

        val rv = view.findViewById(R.id.eventsList) as RecyclerView
        rv.layoutManager = layoutManager

        adapter = EventsAdapter(events, this::eventClicked)
        rv.adapter = adapter

        val fab = view.findViewById(R.id.addButton) as FloatingActionButton
        fab.setOnClickListener {
            val intent = Intent(activity, AddEventActivity::class.java)
            startActivity(intent)
        }

        listenForChanges()

        return view
    }

    fun addEvent(event: Event) {
        events.add(event)
        this.adapter?.notifyDataSetChanged()
    }

    fun deleteEvent(eventId:String)
    {
        for (event in events) {
            if (event.id == eventId)
                events.remove(event)
        }
        this.adapter?.notifyDataSetChanged()
    }

    private fun eventClicked(event: Event)
    {
        val intent = Intent(activity, EventDetailActivity::class.java)
        intent.putExtra("eventId", event.id)
        startActivity(intent)
    }

    private fun hideProgressBar()
    {
        if (progressBar!=null)
        progressBar.visibility = View.GONE
    }

   private fun listenForChanges()
    {
        if (!flag) {
            eventsListPresenter.listenForChanges()
            flag=true
        }
    }

}
