package fernandoalvarez.eventizer.EventsInvites

import com.google.android.gms.tasks.OnSuccessListener
import com.google.firebase.database.ChildEventListener
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseError
import com.google.firebase.database.ValueEventListener
import fernandoalvarez.eventizer.FirebaseUtil
import fernandoalvarez.eventizer.Model.Event

class EventsInvitesListPresenter(val eventsInvitesListFragment: EventsInvitesListFragment) {

    /*fun getEventsInvites() {
        val listener = object : ValueEventListener {

            override fun onDataChange(dataSnapshot: DataSnapshot) {
                eventsInvitesListFragment.hideProgressBar()
                if (dataSnapshot.hasChildren()) {
                    val p = dataSnapshot.value as HashMap<String,String>
                    p.keys.forEach{
                        getEventById(it)
                    }
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getEventsInvites(listener)
    }*/

    private fun getEventById(id:String){
        val listener = object :ValueEventListener {
            override fun onDataChange(dataSnapshot: DataSnapshot) {
                if (dataSnapshot.hasChildren()) {
                    val event = dataSnapshot.getValue(Event::class.java)
                    eventsInvitesListFragment.addEventInvite(event!!)
                }
            }

            override fun onCancelled(databaseError: DatabaseError) {
                println("The read failed: " + databaseError.code)
            }
        }
        FirebaseUtil.getEventById(listener,id)
    }

    fun acceptEventInvite(eventId:String)
    {
        val listener = OnSuccessListener<Void> {
            //eventsInvitesListFragment.removeEventInvite(eventId)
        }
        FirebaseUtil.acceptEventInvite(listener, eventId)
    }

    fun refuseEventInvite(eventId:String)
    {
        val listener = OnSuccessListener<Void> {
            //eventsInvitesListFragment.removeEventInvite(eventId)
        }
        FirebaseUtil.refuseEventInvite(listener, eventId)
    }

    fun listenForChanges() {
        val listener = object : ChildEventListener {
            override fun onCancelled(p0: DatabaseError?) {}

            override fun onChildMoved(p0: DataSnapshot?, p1: String?) {}

            override fun onChildChanged(p0: DataSnapshot?, p1: String?) {}

            override fun onChildAdded(p0: DataSnapshot?, p1: String?) {
                getEventById(p0!!.key)
            }

            override fun onChildRemoved(p0: DataSnapshot?) {
                eventsInvitesListFragment.removeEventInvite(p0!!.key)
            }
        }
        FirebaseUtil.listenForInvitesChanges(listener)
    }

}