package fernandoalvarez.eventizer.EventsInvites

import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.Event
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.events_invites_layout.view.*

class EventsInvitesAdapter (val eventsInvitesList: ArrayList<Event>,
                            private val clickListener: (Event, String) -> Unit): RecyclerView.Adapter<EventsInvitesAdapter.ViewHolder>() {

    override fun onBindViewHolder(holder: ViewHolder, position: Int) {
        holder.bind(eventsInvitesList[position], clickListener)
    }

    override fun onCreateViewHolder(parent: ViewGroup, viewType: Int): ViewHolder {
        val v = LayoutInflater.from(parent.context).inflate(R.layout.events_invites_layout, parent, false)
        return ViewHolder(v)
    }

    override fun getItemCount(): Int {
        return eventsInvitesList.size
    }

    class ViewHolder(itemView: View): RecyclerView.ViewHolder(itemView){
        fun bind(eventInvite: Event, clickListener: (Event, String) -> Unit) {
            itemView.eventTitle.text = eventInvite.title
            itemView.eventDate.text = eventInvite.date
            itemView.eventTime.text = eventInvite.time
            itemView.acceptInvite.setOnClickListener { clickListener(eventInvite,"ACCEPTED") }
            itemView.discardInvite.setOnClickListener { clickListener(eventInvite,"DISCARDED")  }
        }

    }

}