package fernandoalvarez.eventizer.EventsInvites

import android.os.Bundle
import android.support.v4.app.Fragment
import android.support.v7.widget.LinearLayoutManager
import android.support.v7.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import fernandoalvarez.eventizer.Model.Event
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.fragment_events_invites_list.*

class EventsInvitesListFragment : Fragment() {

    private var eventsInvitesListPresenter: EventsInvitesListPresenter = EventsInvitesListPresenter(this)
    private var layoutManager: RecyclerView.LayoutManager? = null
    private var adapter: RecyclerView.Adapter<EventsInvitesAdapter.ViewHolder>? = null
    private var eventsInvites = ArrayList<Event>()
    private var flag:Boolean = false

    override fun onStart() {
        super.onStart()
        hideProgressBar()
    }

/*    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
    }*/

    override fun onCreateView(inflater: LayoutInflater, container: ViewGroup?,
                              savedInstanceState: Bundle?): View? {

        val view = inflater.inflate(R.layout.fragment_events_invites_list, container, false)

        layoutManager = LinearLayoutManager(context)

        val rv = view.findViewById(R.id.eventsInvitesList) as RecyclerView
        rv.layoutManager = layoutManager

        adapter = EventsInvitesAdapter(eventsInvites, this::eventInviteClicked)
        rv.adapter = adapter

        //eventsInvites.clear()
        listenForChanges()
        return view
    }

    fun addEventInvite(event: Event)
    {
        eventsInvites.add(event)
        this.adapter?.notifyDataSetChanged()
    }

    fun removeEventInvite(eventId: String)
    {
        for (eventsInvite in eventsInvites) {
            if (eventsInvite.id == eventId)
                eventsInvites.remove(eventsInvite)
        }
        this.adapter?.notifyDataSetChanged()
    }

    private fun eventInviteClicked(eventInvite: Event, action: String)
    {
        if (action == "ACCEPTED")
        {
            eventsInvitesListPresenter.acceptEventInvite(eventInvite.id)
        }
        else if (action == "DISCARDED")
        {
            eventsInvitesListPresenter.refuseEventInvite(eventInvite.id)
        }
    }

   private fun hideProgressBar()
    {
        if (progressBar!=null)
        progressBar.visibility = View.GONE
    }

    private fun listenForChanges()
    {
        if (!flag)
        {
            eventsInvitesListPresenter.listenForChanges()
            flag=true
        }
    }

}
