package fernandoalvarez.eventizer.Login

import com.google.android.gms.tasks.Task
import com.google.firebase.auth.AuthResult
import fernandoalvarez.eventizer.FirebaseUtil

class LoginPresenter(private val loginActivity: LoginActivity) {

    fun performLogin(email: String, password: String) {
        FirebaseUtil.performLogin(email, password).addOnCompleteListener { task: Task<AuthResult> ->
            if (task.isSuccessful) {
                loginActivity.goToMainMenu()
            }
            else
            {
                loginActivity.showBadCredentialsMessage()
            }
        }
    }
}