package fernandoalvarez.eventizer.Register

import android.content.Intent
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Patterns
import com.basgeekball.awesomevalidation.AwesomeValidation
import com.basgeekball.awesomevalidation.ValidationStyle
import com.basgeekball.awesomevalidation.utility.RegexTemplate
import fernandoalvarez.eventizer.Login.LoginActivity
import fernandoalvarez.eventizer.R
import kotlinx.android.synthetic.main.activity_register.*

class RegisterActivity : AppCompatActivity() {

    private lateinit var registerPresenter : RegisterPresenter
    private var awesomeValidation: AwesomeValidation? = null

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        awesomeValidation = AwesomeValidation(ValidationStyle.BASIC)
        setContentView(R.layout.activity_register)
        addValidation()
        registerPresenter = RegisterPresenter(this)
        listenersSetup()
    }

    private fun listenersSetup()
    {
        registerButton.setOnClickListener{
            if (awesomeValidation!!.validate())
            registerPresenter.registerUser(emailField.text.toString(), passwordField.text.toString(), usernameField.text.toString())
        }
    }

    fun goToLoginForm()
    {
        val intent = Intent(this, LoginActivity::class.java)
        startActivity(intent)
    }

    private fun addValidation()
    {
        awesomeValidation?.addValidation(usernameField,RegexTemplate.NOT_EMPTY,getString(R.string.username_validation_error))
        awesomeValidation?.addValidation(emailField, Patterns.EMAIL_ADDRESS, getString(R.string.mail_validation_error))
        val regexPassword = ".{8,}";
        awesomeValidation?.addValidation(passwordField, regexPassword,getString(R.string.password_validation_error))
        awesomeValidation?.addValidation(repeatPasswordField,passwordField,getString(R.string.repeat_password_validation_error))
    }

}
